Debian Bug report logs - #483328
pvm: FTBFS: dpkg-shlibdeps: failure: couldn't find library libpvm3.so.3 needed by debian/pvm/usr/bin/pvm (its RPATH is '').

version graph

Package: pvm; Maintainer for pvm is Steinar H. Gunderson <sesse@debian.org>; Source for pvm is src:pvm.

Reported by: Lucas Nussbaum <lucas@lucas-nussbaum.net>

Date: Wed, 28 May 2008 10:54:47 UTC

Severity: serious

Tags: patch

Found in version pvm/3.4.5-10

Fixed in version pvm/3.4.5-11

Done: sesse@debian.org (Steinar H. Gunderson)

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, sesse@debian.org (Steinar H. Gunderson):
Bug#483328; Package pvm. Full text and rfc822 format available.

Acknowledgement sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
New Bug report received and forwarded. Copy sent to sesse@debian.org (Steinar H. Gunderson). Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Lucas Nussbaum <lucas@lucas-nussbaum.net>
To: submit@bugs.debian.org
Subject: pvm: FTBFS: dpkg-shlibdeps: failure: couldn't find library libpvm3.so.3 needed by debian/pvm/usr/bin/pvm (its RPATH is '').
Date: Wed, 28 May 2008 14:35:25 +0200
Package: pvm
Version: 3.4.5-10
Severity: serious
User: debian-qa@lists.debian.org
Usertags: qa-ftbfs-20080527 qa-ftbfs
Justification: FTBFS on i386

Hi,

During a rebuild of all packages in sid, your package failed to build on
i386.

Relevant part:
>  /usr/bin/fakeroot debian/rules binary
> dh_testdir
> dh_testroot
> dh_clean -k
> dh_installdirs
> # pvm package
> mv bin/`sh debian/getpvmarch`/pvmgs debian/pvm/usr/bin
> cp lib/pvmgetarch debian/pvm/usr/bin
> cp lib/`sh debian/getpvmarch`/pvm debian/pvm/usr/bin
> cp lib/`sh debian/getpvmarch`/pvmgs debian/pvm/usr/bin
> cp lib/`sh debian/getpvmarch`/pvmd3 debian/pvm/usr/bin/pvmd
> ln -sf ../../../bin/pvmgetarch debian/pvm/usr/lib/pvm3/lib/pvmgetarch
> ln -sf ../../../bin/pvm debian/pvm/usr/lib/pvm3/lib/pvm
> ln -sf ../../../bin/pvmgs debian/pvm/usr/lib/pvm3/lib/pvmgs
> ln -sf ../../../bin/pvmd debian/pvm/usr/lib/pvm3/lib/pvmd
> # pvm-dev package
> cp lib/aimk debian/pvm-dev/usr/bin
> mv bin/`sh debian/getpvmarch`/{pvm_gstat,pvmgroups,tracer,trcsort} debian/pvm-dev/usr/bin
> cp lib/`sh debian/getpvmarch`/*.a debian/pvm-dev/usr/lib
> cp conf/`sh debian/getpvmarch`.{def,m4} debian/pvm-dev/usr/lib/pvm3/conf
> cp include/* debian/pvm-dev/usr/include
> ln -sf libpvm3.so.10 debian/pvm-dev/usr/lib/libpvm3.so
> ln -sf libgpvm3.so.10 debian/pvm-dev/usr/lib/libgpvm3.so
> # libpvm3 package
> cp lib/`sh debian/getpvmarch`/libpvm3.so debian/libpvm3/usr/lib/libpvm3.so.10
> ln -s libpvm3.so.10 debian/libpvm3/usr/lib/libpvm3.so.1
> cp lib/`sh debian/getpvmarch`/libgpvm3.so debian/libpvm3/usr/lib/libgpvm3.so.10
> ln -s libgpvm3.so.10 debian/libpvm3/usr/lib/libgpvm3.so.1
> # pvm-examples package
> mv bin/`sh debian/getpvmarch`/gs debian/pvm-examples/usr/bin/gs.pvm
> mv bin/`sh debian/getpvmarch`/hello debian/pvm-examples/usr/bin/hello.pvm
> mv bin/`sh debian/getpvmarch`/srm debian/pvm-examples/usr/bin/srm.pvm
> cp bin/`sh debian/getpvmarch`/* debian/pvm-examples/usr/bin/
> tar zcf examples.tar.gz examples
> tar zcf gexamples.tar.gz gexamples
> dh_installdocs Readme Readme.mp
> dh_installdocs -ppvm-examples examples.tar.gz gexamples.tar.gz
> dh_installchangelogs
> dh_strip
> dh_fixperms
> dh_installman
> dh_compress
> dh_installdeb
> dh_makeshlibs
> dh_shlibdeps -L libpvm3 -l debian/libpvm3/usr/lib
> dpkg-shlibdeps: failure: couldn't find library libpvm3.so.3 needed by debian/pvm/usr/bin/pvm (its RPATH is '').
> Note: libraries are not searched in other binary packages that do not have any shlibs or symbols file.
> To help dpkg-shlibdeps find private libraries, you might need to set LD_LIBRARY_PATH.
> dh_shlibdeps: command returned error code 512
> make: *** [binary-arch] Error 1

The full build log is available from:
   http://people.debian.org/~lucas/logs/2008/05/27

This rebuild was done with gcc 4.3 instead of gcc 4.2, because gcc 4.3
is now the default on most architectures (even if it's not the case on
i386 yet).  Consequently, many failures are caused by the switch to gcc
4.3.
If you determine that this failure is caused by gcc 4.3, feel free to
downgrade this bug to 'important' if your package is only built on i386,
and this bug is specific to gcc 4.3 (i.e the package builds fine with
gcc 4.2).

A list of current common problems and possible solutions is available at 
http://wiki.debian.org/qa.debian.org/FTBFS . You're welcome to contribute!

About the archive rebuild: The rebuild was done on about 50 AMD64 nodes
of the Grid'5000 platform, using a clean chroot containing a sid i386
environment.  Internet was not accessible from the build systems.

-- 
| Lucas Nussbaum
| lucas@lucas-nussbaum.net   http://www.lucas-nussbaum.net/ |
| jabber: lucas@nussbaum.fr             GPG: 1024D/023B3F4F |




Information forwarded to debian-bugs-dist@lists.debian.org, sesse@debian.org (Steinar H. Gunderson):
Bug#483328; Package pvm. Full text and rfc822 format available.

Acknowledgement sent to peter green <plugwash@p10link.net>:
Extra info received and forwarded to list. Copy sent to sesse@debian.org (Steinar H. Gunderson). Full text and rfc822 format available.

Message #10 received at 483328@bugs.debian.org (full text, mbox):

From: peter green <plugwash@p10link.net>
To: 483328@bugs.debian.org
Cc: control@bugs.debian.org
Subject: re: pvm: FTBFS: dpkg-shlibdeps: failure: couldn't find library libpvm3.so.3 needed by debian/pvm/usr/bin/pvm (its RPATH is '').
Date: Sun, 08 Jun 2008 02:39:21 +0100
tags 483328 +patch
thanks

The package built fine in my (reasaonblly up to date but not clean) sid 
chroot.

Some build log comparisons between the output of my successfull build 
and lucas's revealed the following rather weired difference.

my output (successfull build)

# pvm-dev package
cp lib/aimk debian/pvm-dev/usr/bin
mv bin/`sh debian/getpvmarch`/{pvm_gstat,pvmgroups,tracer,trcsort} 
debian/pvm-de
cp lib/`sh debian/getpvmarch`/*.a debian/pvm-dev/usr/lib
cp conf/`sh debian/getpvmarch`.{def,m4} debian/pvm-dev/usr/lib/pvm3/conf
cp include/* debian/pvm-dev/usr/include
ln -sf libpvm3.so.3.4.5 debian/pvm-dev/usr/lib/libpvm3.so
ln -sf libgpvm3.so.3.4.5 debian/pvm-dev/usr/lib/libgpvm3.so
# libpvm3 package
cp lib/`sh debian/getpvmarch`/libpvm3.so 
debian/libpvm3/usr/lib/libpvm3.so.3.4.5
ln -s libpvm3.so.3.4.5 debian/libpvm3/usr/lib/libpvm3.so.3
cp lib/`sh debian/getpvmarch`/libgpvm3.so 
debian/libpvm3/usr/lib/libgpvm3.so.3.4
ln -s libgpvm3.so.3.4.5 debian/libpvm3/usr/lib/libgpvm3.so.3

lucas's output (failed build)

# pvm-dev package
cp lib/aimk debian/pvm-dev/usr/bin
mv bin/`sh debian/getpvmarch`/{pvm_gstat,pvmgroups,tracer,trcsort} debian/pvm-dev/usr/bin
cp lib/`sh debian/getpvmarch`/*.a debian/pvm-dev/usr/lib
cp conf/`sh debian/getpvmarch`.{def,m4} debian/pvm-dev/usr/lib/pvm3/conf
cp include/* debian/pvm-dev/usr/include
ln -sf libpvm3.so.10 debian/pvm-dev/usr/lib/libpvm3.so
ln -sf libgpvm3.so.10 debian/pvm-dev/usr/lib/libgpvm3.so
# libpvm3 package
cp lib/`sh debian/getpvmarch`/libpvm3.so debian/libpvm3/usr/lib/libpvm3.so.10
ln -s libpvm3.so.10 debian/libpvm3/usr/lib/libpvm3.so.1
cp lib/`sh debian/getpvmarch`/libgpvm3.so debian/libpvm3/usr/lib/libgpvm3.so.10
ln -s libgpvm3.so.10 debian/libpvm3/usr/lib/libgpvm3.so.1


so instead of .3.4.5 we have .10 and instead of .3 we have .1

those  numbers come from the following lines in debian/rules

version=$(shell expr `pwd` : '.*-\([0-9.]*\)')
version_major=$(shell expr `pwd` : '.*-\([0-9]*\).[0-9.]*')

It is conventional to unpack debian packages in a directory named 
<packagename>-<upstream version> but lucas unpacks them in a directory 
called <packagename>-<full version> causing the ftbfs.

The following is a more correct replacement that obtains the information 
from debian/changelog rather than the directory name

version=$(shell dpkg-parsechangelog | grep Version: | cut -d ' ' -f 2 | 
cut -d '-' -f 1)
version_major=$(shell echo $(version) | cut -d '.' -f 1 )

with this change the package builds fine in a directory following 
lucas's convention




Tags added: patch Request was from peter green <plugwash@p10link.net> to control@bugs.debian.org. (Sun, 08 Jun 2008 01:42:03 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, sesse@debian.org (Steinar H. Gunderson):
Bug#483328; Package pvm. Full text and rfc822 format available.

Acknowledgement sent to Simon McVittie <smcv@debian.org>:
Extra info received and forwarded to list. Copy sent to sesse@debian.org (Steinar H. Gunderson). Full text and rfc822 format available.

Message #17 received at 483328@bugs.debian.org (full text, mbox):

From: Simon McVittie <smcv@debian.org>
To: 483328@bugs.debian.org
Subject: pvm: diff for NMU version 3.4.5-10.1
Date: Sun, 29 Jun 2008 15:54:36 +0100
[Message part 1 (text/plain, inline)]
tags 483328 + patch
thanks

I've succeeded in getting pvm to build, and fixed some of the more
significant breakages. I'm *not* NMUing this at this stage, because I have no
idea how to test that it's still functional. The diff so far is
attached.

Also, I've fixed the "incompatible implicit declaration of built-in
function" warnings, but adding -Wall causes many implicit declaration
warnings for (presumably) libpvm internals. This means it might well
segfault on architectures where the int and pointer are different
sizes...

    Simon
    at the Cambridge BSP
[pvm-3.4.5-10.1-nmu.diff (text/x-diff, attachment)]
[signature.asc (application/pgp-signature, inline)]

Tags added: patch Request was from Simon McVittie <smcv@debian.org> to control@bugs.debian.org. (Sun, 29 Jun 2008 14:57:04 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, sesse@debian.org (Steinar H. Gunderson):
Bug#483328; Package pvm. Full text and rfc822 format available.

Acknowledgement sent to "Steinar H. Gunderson" <sgunderson@bigfoot.com>:
Extra info received and forwarded to list. Copy sent to sesse@debian.org (Steinar H. Gunderson). Full text and rfc822 format available.

Message #24 received at 483328@bugs.debian.org (full text, mbox):

From: "Steinar H. Gunderson" <sgunderson@bigfoot.com>
To: Simon McVittie <smcv@debian.org>, 483328@bugs.debian.org
Subject: Re: Bug#483328: pvm: diff for NMU version 3.4.5-10.1
Date: Wed, 2 Jul 2008 23:15:20 +0200
On Sun, Jun 29, 2008 at 03:54:36PM +0100, Simon McVittie wrote:
> I've succeeded in getting pvm to build, and fixed some of the more
> significant breakages. I'm *not* NMUing this at this stage, because I have no
> idea how to test that it's still functional. The diff so far is
> attached.

Thanks for taking care of this!

I'm unsure of some of these changes -- pvm is an old package, and given that
there's little use and almost no upstream development, I'm not sure if
possible destabilization (in particular wrt. the shared library madness) is
worth it. Actually I'm not sure if this bug should be RC at all, but that's a
different story...

I'm going to go ahead and upload with the proposed debian/rules changes (or
at least something based on them). Again, thanks, and happy bugsquashing.

/* Steinar */
-- 
Homepage: http://www.sesse.net/




Reply sent to sesse@debian.org (Steinar H. Gunderson):
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Lucas Nussbaum <lucas@lucas-nussbaum.net>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #29 received at 483328-close@bugs.debian.org (full text, mbox):

From: sesse@debian.org (Steinar H. Gunderson)
To: 483328-close@bugs.debian.org
Subject: Bug#483328: fixed in pvm 3.4.5-11
Date: Wed, 02 Jul 2008 22:02:09 +0000
Source: pvm
Source-Version: 3.4.5-11

We believe that the bug you reported is fixed in the latest version of
pvm, which is due to be installed in the Debian FTP archive:

libpvm3_3.4.5-11_i386.deb
  to pool/main/p/pvm/libpvm3_3.4.5-11_i386.deb
pvm-dev_3.4.5-11_i386.deb
  to pool/main/p/pvm/pvm-dev_3.4.5-11_i386.deb
pvm-examples_3.4.5-11_i386.deb
  to pool/main/p/pvm/pvm-examples_3.4.5-11_i386.deb
pvm_3.4.5-11.diff.gz
  to pool/main/p/pvm/pvm_3.4.5-11.diff.gz
pvm_3.4.5-11.dsc
  to pool/main/p/pvm/pvm_3.4.5-11.dsc
pvm_3.4.5-11_i386.deb
  to pool/main/p/pvm/pvm_3.4.5-11_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 483328@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Steinar H. Gunderson <sesse@debian.org> (supplier of updated pvm package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Wed, 02 Jul 2008 23:16:11 +0200
Source: pvm
Binary: pvm pvm-dev libpvm3 pvm-examples
Architecture: source i386
Version: 3.4.5-11
Distribution: unstable
Urgency: high
Maintainer: Steinar H. Gunderson <sesse@debian.org>
Changed-By: Steinar H. Gunderson <sesse@debian.org>
Description: 
 libpvm3    - Parallel Virtual Machine - shared libraries
 pvm        - Parallel Virtual Machine - binaries
 pvm-dev    - Parallel Virtual Machine - development files
 pvm-examples - Parallel Virtual Machine - examples
Closes: 483328
Changes: 
 pvm (3.4.5-11) unstable; urgency=high
 .
   * In debian/rules, pick out the version number from the changelog instead of
     from the current directory name; fixes FTBFS if the directory has been
     renamed for some reason. Baed on patch from Simon McVittie and Peter Green.
     (Closes: #483328)
Checksums-Sha1: 
 65749b054b9bdc1d9f20e8dcc3be4352c3a4aefe 1042 pvm_3.4.5-11.dsc
 f1ca9af08dabbf71087faf9049c27f0419477c6d 20814 pvm_3.4.5-11.diff.gz
 60d31af561087bd47091c9e789f3f5742c29ab65 161744 pvm_3.4.5-11_i386.deb
 7608b93c0b979f8384aaf6d88ff06bd7090823e6 345374 pvm-dev_3.4.5-11_i386.deb
 daa9f4e45bd364ec80ac7af28ae0669e1641d67d 90358 libpvm3_3.4.5-11_i386.deb
 60b94a2733310b27863714a4d4a770e48901dc05 200872 pvm-examples_3.4.5-11_i386.deb
Checksums-Sha256: 
 1f8214c19c9b2cb20c0bf4b1c394425609b39832ce92bd168e80a7a17d2e8904 1042 pvm_3.4.5-11.dsc
 78225f58cb640f8f5a636eec02f32493c9105f301c22d35aab6aa4ea8f7fb173 20814 pvm_3.4.5-11.diff.gz
 01419bd01872708c4e8bb451751e38cbf0a4d8bce02157131a1125373c18b6a0 161744 pvm_3.4.5-11_i386.deb
 fa7dc2b8052a798b0416ab9c7ba84ea612eda7eea7ac494c86907a136f4fb3ab 345374 pvm-dev_3.4.5-11_i386.deb
 94ea9ae71e7ef4a9a1100a1f895e9a5881ba93a470314fa30f899e34cdcd1ec2 90358 libpvm3_3.4.5-11_i386.deb
 0223214cd3411034c2e1cc7c27f927447e00e4f2eaf530e56888445d4ab8f95e 200872 pvm-examples_3.4.5-11_i386.deb
Files: 
 e1778c64eb1e58d810d71f29874e121e 1042 devel extra pvm_3.4.5-11.dsc
 489c9be9472433abe2c12b31a7bf0b22 20814 devel extra pvm_3.4.5-11.diff.gz
 4d8c0a137ec0d6cad70ed78824592780 161744 devel extra pvm_3.4.5-11_i386.deb
 6d6203cc5dc52d21b2ba5ff72ad498ed 345374 devel extra pvm-dev_3.4.5-11_i386.deb
 ceda8660295486236f38c7f61517089e 90358 libs extra libpvm3_3.4.5-11_i386.deb
 0f295b82a6c0138e3e87513c8d3e45f6 200872 devel extra pvm-examples_3.4.5-11_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.9 (GNU/Linux)

iD8DBQFIa/aRXKRQ3lK3SH4RAlQoAJ9Veeyvk548ZACSzG1mpGTI9/c/VQCeKIPN
UtyT+RIKJn8HMWdAEvoIwic=
=Wrde
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Sun, 10 Aug 2008 12:15:02 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 20:48:01 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.